EDIT - bug #8297

Fix condensed distribution string for E+M
05/23/2019 11:53 AM - Andreas Mdller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 100%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 5.21

Severity: normal Found in Version:

Description

for previous rules and discussions see also #3907 and other related tickets.

http://portal.cybertaxonomy.org/euromed/cdm_dataportal/taxon/6a8e85bd-5e52-4ae2-9444-99128c87a672

http://ww2.bgbm.org/EuroPlusMed/PTaxonDetail.asp?NameCache=Abies%20alba&PTRefFk=7500000

Some issues from old+new A. alba comparison:

[ ]

EM endemism should come first and should not show area label
¢ Subareas of fallback areas (Ju etc) should not be handled in brackets, Ju should not appear if any subarea data exists
e /77

¢ [dCy]/ DCy

¢ old: Ga(F) and [cGa(F)] in same string => error according to ERS

e nHb(E N) / nHb(E) nHb(N)

webservice results: example

portal code is in modules/cdm_dataportal/includes/descriptions.inc ab Zeile 787 in der function
compose_feature_block_distribution($taxon, $descriptionElements, $feature)

known errors in BM portal:
¢ Areas with native and introduced status are shown in the native and in the foreign part but should only be shown once (with the

highest status), e.g. Ga(F) in
http://ww2.bgbm.org/EuroPlusMed/PTaxonDetail.asp?NameCache=Abies%20alba&PTRefFk=7500000

Comparison with Cuba:

Cuba: areas always bold

Cuba: has outOfScope areas split with " -
EM: has "introduced" (foreign origin) areas in square brackets

Cuba: has not subareas with abbrevlabel including the parent area and the parent part needs to be removed
EM: if status is the same in all subareas it should only be shown on the parent area level

Related issues:

Related to EDIT - feature request #3907: EuroMed: implement condensed "status... Closed
Related to EDIT - feature request #5050: revise the subAreaPreference rule fo... Closed
Related to EDIT - feature request #5779: Update EuroPlusMedCondensedDistribut... Closed
Related to EDIT - feature request #5682: Implement condensed distribution str... Closed
Related to EDIT - bug #7107: "Omit level" (TDWG Level2) in distribution hiera... Discussed
Related to EDIT - bug #7096: Add second symbol attribute to DefinedTermBase Resolved
Related to EDIT - bug #8858: Ordering of distribution status 'undefined' is n... Closed
Related to EDIT - bug #5206: Status symbols in condensed distribution string ... Closed
Related to EDIT - feature request #9484: Distinguish default hidden/fallback ... Rejected
Related to EDIT - feature request #9500: Allow removing certain distribution ... Feedback
Related to EDIT - task #9501: Find inconsistent higher area distribution stat... New
Related to EDIT - feature request #9502: Implement subarea preference rule an... Resolved
https://dev.e-taxonomy.eu/redmine/issues/3907
http://portal.cybertaxonomy.org/euromed/cdm_dataportal/taxon/6a8e85bd-5e52-4ae2-9444-99128c87a672
http://ww2.bgbm.org/EuroPlusMed/PTaxonDetail.asp?NameCache=Abies%20alba&PTRefFk=7500000
http://api.cybertaxonomy.org/euromed/portal/description/distributionInfoFor/0eb6ca37-3365-4af5-a800-8fc4b8c366fa.json?recipe=EuroPlusMed&statusOrderPreference=1&subAreaPreference=1&hiddenAreaMarkerType=e2b42891-aa85-4a09-981b-b7d8f5749c54%2C0318c67d-e323-4e9c-bffb-bc0c7f8f9f40&part=mapUriParams&part=condensedDistribution&part=tree&statusColors=%7B%0D%0A++++%22p%22%3A+%22%239CDF00%22%2C%0D%0A++++%22n%22%3A+%22%23008000%22%2C%0D%0A++++%22nd%22%3A+%22%2300FF00%22%2C%0D%0A++++%22nq%22%3A+%22%2300c8b4%22%2C%0D%0A++++%22f%22%3A+%22%23FFFFFF%22%2C%0D%0A++++%22in%22%3A+%22%23C86400%22%2C%0D%0A++++%22i%22%3A+%22%23C89600%22%2C%0D%0A++++%22ip%22%3A+%22%23C89600%22%2C%0D%0A++++%22ia%22%3A+%22%23c8c800%22%2C%0D%0A++++%22iq%22%3A+%22%23ffc896%22%2C%0D%0A++++%22c%22%3A+%22%23ffff00%22%0D%0A%7D
http://ww2.bgbm.org/EuroPlusMed/PTaxonDetail.asp?NameCache=Abies%20alba&PTRefFk=7500000

Related to EDIT - feature request #9503: Handle term tree of areas and distri... Closed

Related to EDIT - feature request #9521: Fallback areas in textual representa... Closed
Related to EDIT - bug #9526: Sort order in E+M distribution string should be ... Closed
Related to EDIT - feature request #10210: Ul for configuring condensed distri... New

Related to EDIT - feature request #10330: Handle term tree distribution statu... Closed
Copied to EDIT - bug #9583: Fix formatting of parent area in condensed distri... Closed

Associated revisions

Revision ec7eaac5 - 02/23/2021 06:20 PM - Andreas Miiller

ref #8297 refactor condensed distribution string handling

Revision ac1f39b4 - 02/23/2021 10:14 PM - Andreas Miiller

ref #8297 make isAnylntroduced transient

Revision 26527252 - 02/23/2021 11:16 PM - Andreas Miiller

ref #8297 some minor adaptations and adding taggedText to CondensedDistribution bean

Revision 7f7649e0 - 02/24/2021 12:14 PM - Andreas Miiller

ref #8297 adapt dataportal code to new condensed distribution string handling

Revision dd4317ec - 02/25/2021 03:21 PM - Andreas Muller

ref #8297 use CondensedDistributionConfiguration instead -Recipe where possible and improve hidden+fallbackArea handling

Revision 2b5b8997 - 02/26/2021 07:05 PM - Andreas Miiller
ref #8297, ref #9484 temporarily handle isEmpty similar to use default until #9484 is fixed

Revision 455700e0 - 02/26/2021 11:44 PM - Andreas Miiller

ref #8297 handle fallback areas correctly in CondensedDistributionComposer

Revision e657f466 - 03/05/2021 10:44 PM - Andreas Miiller
ref #9500, ref #8297 preliminary add filter for "undefined" status

Revision 6f6d0ba9 - 03/06/2021 12:20 AM - Andreas Miiller
ref #9500, ref #8297 fix undefined filter

Revision 91626e96 - 03/06/2021 01:11 AM - Andreas Miiller
ref #9500, ref #8297 fix undefined filter (cont.)

Revision ¢729e881 - 03/11/2021 10:10 AM - Andreas Miiller

ref #8297, ref #9521 test for recursive fallback area recognition in filterDistributions

Revision e436a9ce - 05/12/2021 07:22 PM - Andreas Miiller

ref #8297 improve out of scope handling for alphabetically ordered condensed distributions

History

#1 - 05/23/2019 11:53 AM - Andreas Miiller

- Related to feature request #3907: EuroMed: implement condensed "status" string of distribution information added

#2 - 05/23/2019 11:54 AM - Andreas Miiller

- Related to feature request #5050: revise the subAreaPreference rule for filtering Distributions added

#3 - 05/23/2019 11:54 AM - Andreas Miiller
- Related to feature request #5779: Update EuroPlusMedCondensedDistributionComposer to use new symbol field added

#4 - 05/23/2019 11:55 AM - Andreas Miiller

- Related to feature request #5682: Implement condensed distribution string for Cuba added
#5 - 05/23/2019 11:57 AM - Andreas Miiller

- Description updated

#6 - 02/07/2021 10:49 PM - Andreas Miiller

- Description updated

#7 - 02/16/2021 12:21 PM - Andreas Miiller

- Description updated

#8 - 02/16/2021 01:56 PM - Andreas Miiller

- Description updated

#9 - 02/16/2021 03:21 PM - Andreas Miiller

- Description updated

#10 - 02/16/2021 07:25 PM - Andreas Miiller

- Description updated

#11 - 02/16/2021 07:26 PM - Andreas Miiller

- Description updated

#12 - 02/17/2021 08:55 AM - Andreas Miiller

- Description updated

#13 - 02/17/2021 09:06 AM - Andreas Miiller

- Description updated

#14 - 02/17/2021 09:08 AM - Andreas Muller
AM:

Wenn es fir ein Areal Unterareale gibt und diese haben einmal einen indigenous und einmal einen ,foreign“ Status, dann soll das Areal 2x aufgeftihrt
werden, einmal im indigenous Bereich und einmal bei foreign, korrekt? Beispiel Uk auf
http://ww2.bgbm.org/EuroPlusMed/PTaxonDetail.asp?NameCache=Crepis%20capillaris&PTRefFk=7000000 , dort kommt -Uk(K) und UK(U) getrennt
vor.

Das ist vermutlich korrekt so und soll so ein? (abgesehen davon, dass Uk glaube ich inzwischen nicht mehr Uberareal der beiden Areale ist, aber mir
geht es nur ums Prinzip)

ERS:

ja, das ist richtig so. Wisste nicht, wie man es sinnvoll anders machen sollte.

#15 - 02/17/2021 09:09 AM - Andreas Miiller
- Status changed from New to In Progress

- % Done changed from 0 to 10

AM:

Wenn die Subareale beide z.B. indigenous sind, aber unterschiedliche Status haben, sollen die Hauptareale dann mehrfach angezeigt werden? In
http://ww2.bgbm.org/EuroPlusMed/PTaxonDetail.asp?NameCache=Erigeron%20acris&PTRefFk=7000000 ist das fiir Tu der Fall (Tu(A) -Tu(E)). Aus
einer alten Mail und alten Tickets entnehme ich aber, dass das evtl. nicht so gewollt ist. Wenn sie nur einfach angezeigt werden sollen, wie soll dann
die Formatierung erfolgen. Grundsatzlich das Hauptareal ohne fett und ohne Préafix, dafir die Subareale entsprechend formatiert? Also im obigen
Beispiel Tu(A -E) ?

Bei gleichem Status soll ja nur das Hauptareal formatiert sein bzw. bei native soll wohl auch die Klammer sowie die Subareale fett sein, korrekt?

ERS:

unterschiedliche Lésungen sind denkbar, die Frage ist, was ist am Intuitivsten. Ich denke besonders auch an Uberareale mit vielen Unterarealen wie
Rf oder Ca. Da ist es sinnvoll, die Hauptareale nur einfach, nicht mehrfach anzuzeigen, denke ich. Fur die Fomatierung kdnnte ich mir besser
vorstellen, dass das Hauptareal fett bleibt, wenn mindestens ein Unterareal native ist (denn d.h., dass die Sippe im Hauptareal ebenfalls native ist).
Also Tu(A -E). oder Ca(?C dF G HdL P T) In jedem Fall bleibt das Hauptareal ohne Praefix.

=> fixed in #9583
http://ww2.bgbm.org/EuroPlusMed/PTaxonDetail.asp?NameCache=Crepis%20capillaris&PTRefFk=7000000
http://ww2.bgbm.org/EuroPlusMed/PTaxonDetail.asp?NameCache=Erigeron%20acris&PTRefFk=7000000
https://dev.e-taxonomy.eu/redmine/issues/9583

#16 - 02/17/2021 10:03 AM - Andreas Miiller

Diskussion mit AK Gber handling des CondensedDistributionString im Portal:

Derzeit werden Teile des Strings hardcodiert im Portalcode erzeugt, wie z.B: die Klammer um die "foreign" Informationen. Um eine einheitliche
Darstellung des Strings tber alle Publikationsmedien hinweg zu erreichen, sollte dies vermieden werden und der String komplett vom
CondensedDistributionComposer erzeugt werden.

Um in Zukunft aber interaktive Zusatzinformationen (z.B. Gber MouseOver) zu Teilen des Strings zu ermdglichen, sollte in einem weiteren Schritt aber
eine TaggedText ahnliche Ausgabe angestrebt werden.

Weiterhin sollten Formatierungsinformationen mit Informationsgehalt wie die fette darstellung von Arealen, die besagt, dass es sich hier um ein
natives Vorkommen handelt, nicht einzig Uber clientseitige Formattierungen implementiert werden sondern sollten Teil des Strings bzw. spéater des
TaggedText sein. Z.B. kénnte das durch Verwendung des HTML Tag im Text erreicht werden, auch wenn dieser innerhalb von HTML eher
deprecated ist. Es kénnte aber auch irgendein anderer eindeutiger Markierer verwendet werden. In der TaggedText Variante kann dies durch ein
TaggedText Attribut einfach implementiert werden.

Noch nicht diskutiert wurde die Hinterlegung der projektspezifischen Konfigurationsparameter, die z.B. in den CdmPreferences erfolgen kénnte.

#17 - 02/18/2021 06:06 PM - Andreas Miiller

- Description updated

#18 - 02/19/2021 11:45 AM - Andreas Miuller

- Related to bug #7107: "Omit level" (TDWG Level2) in distribution hierarchy should not supress distributions source reference added

#19 - 02/24/2021 03:27 PM - Andreas Miiller
- % Done changed from 10 to 40

Bellis perennis on test: http:/test.e-taxonomy.eu/dataportal/preview/euromed/cdm_dataportal/taxon/0eb6ca37-3365-4af5-a800-8fc4b8c366fa

#20 - 02/24/2021 04:07 PM - Andreas Miiller
ERS (2020-06-23):

Unterareale sollten ja eigentlich in Klammern nach dem Hauptareal zusammengefasst werden, also das Hauptareal nicht wiederholt. Das ist jetzt zum
Teil richtig, zum Teil falsch (siehe z.B. Ganseblimchen https://europlusmed.org/cdm_dataportal/taxon/0eb6ca37-3365-4af5-a800-8fc4b8c366fa

Richtig ist:
L)
L)
N)
S)
Ju(BH Cg Ct SI Sr)

Falsch ist:
AE(G) AE(T) =>AE(GT)

Au(A
Be(B
Hb(E
Hs(A

Ga(C) Ga(F) => Ga(C F)

Rf(C) Rf(CS) Rf(E) Rf(K) Rf(N) Rf(NW) => Rf(S) Rf(C) Rf(CS) Rf(E) Rf(K) Rf(N) Rf(NW) Rf(S)
Tu(A) Tu(E) => Tu(A E)

Uberflussig ist es auch, die Statusangabe immer zu wiederholen, wenn sie fiir alle Unterareale gleich ist.

Also: nAz(JM S T)
nicht: nAz(nd nM nS nT)
und die -EM-Angabe sollte nach vorne geriickt werden.

Ab(A) AE(G) AE(T) Al Ar Au(A L) Be(B L) BI(N) Br Bu By Co Cr Cs Cy Da -IEM Ga(C) Ga(F) Ge Gg Gr Hb(E N) He Ho Hs(A S) Hu Ir ??Is It Jo

Ju(BH Cg Ct SI Sr) Le Lu Ma Md ??Md(M) ??Mk Mo dNo Po Rf(C) Rf(CS) Rf(E) Rf(K) Rf(N) Rf(NW) Rf(S) Rm Sa Si(S) dSi(M) Sk ??Su Sy Tu(A)
Tu(E) Uk(Cm U) [nAz(nd nM nS nT) nEs nFa nFe nLa nL{]

#21 - 02/24/2021 04:59 PM - Andreas Miiller
- Related to bug #7096: Add second symbol attribute to DefinedTermBase added

#22 - 02/24/2021 10:40 PM - Andreas Miiller
- Related to bug #8858: Ordering of distribution status ‘undefined' is not correct in E+M added

#23 - 02/24/2021 11:15 PM - Andreas Miiller
AM:
http://test.e-taxonomy.eu/dataportal/preview/euromed/cdm_dataportal/taxon/0eb6ca37-3365-4af5-a800-8fc4b8c366fa
fur folgende Status brauchte ich noch die korrekten Symbole:
* native: reported in error => ,-“ ? Genauso wie introduced: reported in error? Soll das dann ein minus sein oder ein langerer Strich? 6446 Falle

* native: formerly native => ist das der extinct Fall ,1* aus https://dev.e-taxonomy.eu/redmine/issues/3907 (759 Falle)

« introduced: doubtfully introduced (perhaps cultivated only) => “d” ? (826 Falle) Beispiel: Ageratum houstonianum
Damit wiirden sich dann folgende Symbole fiir die genutzen Verbreitungsstatus ergeben:

"titteCache" "symbol2"
"endemic” "["
"native"

"native: doubtfully native" "d"
"naturalised" "n"

"casual" "a"

"introduced: uncertain degree of naturalisation" "p"

"introduced"

"introduced: doubtfully introduced (perhaps cultivated only)" "d"
"native: presence questionable" "?"

"introduced: presence questionable" "?"

"cultivated” "c"

"not endemic" -0

"unknown endemism" "?[l"

"native: formerly native" "t"

"native: reported in error" "-"

"introduced: reported in error" "-"

"undefined" "??"

SELECT st.titleCache, st.symbol2 -- , st.id, tb.titleCache, COUNT (*) AS n
FROM DescriptionElementBase deb
INNER JOIN DescriptionBase db ON db.id = deb.inDescription_id
INNER JOIN TaxonBase tb ON tb.id = db.taxon_id
LEFT JOIN DefinedTermBase st ON st.id = deb.status_id
WHERE deb.DTYPE = 'Distribution' AND deb.status_id -- AND st.id = 2083
GROUP BY st.id
ORDER BY st.orderIndex

#24 - 02/26/2021 12:08 PM - Andreas Miiller
ERS:

fur native: reported in error gilt das gleiche wie fir introduced: reported in error, ein Minus - vor dem Kiirzel.
formerly native ist Extinct 1", ja.

Und fir not endemic oder unknown endemism wiirde ich keine Symbole verwenden, nur flir endemic. Fiir not endemic ist es einfach nicht tblich, und
far unknown endemism wirde ich ungern auf unsere Licken aufmerksam machen. Denn in den allermeisten Féllen (geschétzt 98%) ist es so, dass
man den Endemismus-Status kennt, der Bearbeiter nur nicht genligend recherchiert hat. Bei ganz wenigen Taxa wére dieser Status wirklich sinnvoll.

#25 - 02/26/2021 06:02 PM - Andreas Miiller

- Related to bug #5206: Status symbols in condensed distribution string repeated for subareas added

#26 - 02/26/2021 06:19 PM - Andreas Miiller

- Description updated

#27 - 02/26/2021 07:03 PM - Andreas Miiller
- Related to feature request #9484: Distinguish default hidden/fallback area handling from empty list of hidden/fallback area markers added

#28 - 02/27/2021 08:27 AM - Andreas Miiller

- Description updated

- Status changed from In Progress to Resolved

- Assignee changed from Andreas Muiller to Eckhard von Raab-Straube

- Target version changed from Euro+Med Portal Release to Release 5.21

- % Done changed from 40 to 50
This should be fixed now and can be reviewed on test or on production after the next release

#29 - 03/01/2021 09:50 AM - Andreas Miiller
AM:

auf introduced: doubtfully introduced (perhaps cultivated only) bist du noch nicht explizit eingegangen in der Mail. Das “d” stimmt also?
ERS:

ja, das sollte stimmen. Gut, das man die Symbole Uber den Term-Editor anpassen kann.

#31 - 03/02/2021 06:56 PM - Andreas Miiller

- Related to feature request #9500: Allow removing certain distribution status from distribution publication added

#32 - 03/02/2021 07:04 PM - Andreas Miiller
- Related to task #9501: Find inconsistent higher area distribution status data in E+M added

#33 - 03/02/2021 07:37 PM - Andreas Miiller

- Related to feature request #9502: Implement subarea preference rule and fallback areas for areas with complex hierarchy added

#34 - 03/02/2021 07:59 PM - Andreas Miiller

- Related to feature request #9503: Handle term tree of areas and distribution status for distributioninfo in dataportal added

#35 - 03/02/2021 08:14 PM - Andreas Miiller

- Assignee changed from Eckhard von Raab-Straube to Andreas Miiller

An open issue:

... sollen im CondensedDistributionString fiir die Uberareale jeweils nur die Unterarealstatus ausgegeben werden, auch wenn es einen abweichenden
Status fiir das Uberareal gibt? Also im konstruierten Fall ,?BI(l dM)“ das ? weglassen? Bisher habe ich das so implementiert, dass NUR im Fall, dass
sowohl alle Unterareale UND das Hauptareal den gleichen Status haben, der Status quasi aggregiert nur vor dem Hauptareal angezeigt wird.
Ansonsten zeige ich die Status einzeln an, auch den vom Hauptareal. Dadurch sieht man dann solche Inkonsistenzen evtl. schneller, aber nattrlich
fuhrt es auch eher zur Verwunderung beim User.

... hoch ein kleiner Nachtrag: bei der derzeitigen Implementierung kann es auch dazu kommen, dass Daten sowohl im native als auch im introduced
Bereich des CondensedDistributionString auftreten, aber mit einem eigentlich nicht passenden Symbol.

Fir das Beispiel Talinum paniculatum (
http://test.e-taxonomy.eu/dataportal/preview/euromed/cdm_dataportal/taxon/3f28aea3-829f-46dc-957a-9991¢c30050f4) ergibt sich z.B.

-Md(??M) [aAu(A) pAz(aF aP) aHu -Md]
#36 - 03/06/2021 01:51 PM - Andreas Miiller

- Related to feature request #9521: Fallback areas in textual representation should always stand alone added

#37 - 03/07/2021 11:30 AM - Andreas Muller

Andreas Miller wrote:
An open issue:

... sollen im CondensedDistributionString fiir die Uberareale jeweils nur die Unterarealstatus ausgegeben werden, auch wenn es einen
abweichenden Status fiir das Uberareal gibt? Also im konstruierten Fall ,?BI(I dM)* das ? weglassen? Bisher habe ich das so implementiert,
dass NUR im Fall, dass sowohl alle Unterareale UND das Hauptareal den gleichen Status haben, der Status quasi aggregiert nur vor dem
Hauptareal angezeigt wird. Ansonsten zeige ich die Status einzeln an, auch den vom Hauptareal. Dadurch sieht man dann solche
Inkonsistenzen evil. schneller, aber natirlich flhrt es auch eher zur Verwunderung beim User.

ERS:
Die von dir erwdhnte bisherige Implementierung, die die unterschiedlichen Status im condensed distribution string so anzeigt wie du es beschreibst,

finde ich gut, auch wenn es verwirrend aussieht, denn wie gesagt, macht es auf Inkonsistenzen aufmerksam. Letztlich kommen wir da um
Datenreinigung nicht drumrum. Besser, als Daten nicht zu zeigen.

#38 - 03/07/2021 11:36 AM - Andreas Miiller

Andreas Muller wrote:

... noch ein kleiner Nachtrag: bei der derzeitigen Implementierung kann es auch dazu kommen, dass Daten sowohl im native als auch im
introduced Bereich des CondensedDistributionString auftreten, aber mit einem eigentlich nicht passenden Symbol.
Far das Beispiel Talinum paniculatum (

http://test.e-taxonomy.eu/dataportal/preview/euromed/cdm_dataportal/taxon/3f28aea3-829f-46dc-957a-9991¢c30050f4) ergibt sich z.B.
-Md(??M) [aAu(A) pAz(aF aP) aHu -Md]

AM

Das tritt primar beim Status "undefined" auf. Dieser wird in Zukunft grundsétzlich nicht mehr im CondDistStr angezeigt werden (#9500), daher ist das
Problem inzwischen relativ, es ware aber sinnvoll nach solchen Fallen zu suchen die nicht mit "undefined" zu tun haben (s. auch #9501).

#39 - 03/07/2021 11:36 AM - Andreas Miiller

This should be fixed. Only code cleanup is needed.

#40 - 03/12/2021 12:05 PM - Andreas Miiller
- Related to bug #9526: Sort order in E+M distribution string should be strictly alphabetic added

#41 - 03/13/2021 05:11 AM - Andreas Miiller
- % Done changed from 50 to 100

Code cleaned-up as far as time for this existed. A followup ticket with an open issue was created: #9526

#42 - 03/13/2021 05:12 AM - Andreas Miiller

- Status changed from Resolved to Closed

#43 - 04/16/2021 07:42 PM - Andreas Miiller

- Copied to bug #9583: Fix formatting of parent area in condensed distributions string if subareas have various status but at least 1 area has status
native added

#44 - 12/19/2022 11:14 AM - Andreas Muller

- Related to feature request #10210: Ul for configuring condensed distribution string via separate parameters added

#45 - 05/27/2023 11:05 PM - Andreas Miiller

- Related to feature request #10330: Handle term tree distribution status for distributioninfo in dataportal added
